---------------------
PatchSet 303 
Date: 2000/05/14 23:22:19
Author: hno
Branch: hno-devel
Tag: (none) 
Log:
Syncronized with modio

Members: 
	configure.in:1.1.1.3.6.7.2.6->1.1.1.3.6.7.2.7 
	doc/Programming-Guide/prog-guide.sgml:1.1.1.2.6.1.2.1->1.1.1.2.6.1.2.2 
	lib/rfc1035.c:1.1.1.1.10.2->1.1.1.1.10.2.2.1 
	src/Makefile.in:1.1.1.3.10.7.2.2->1.1.1.3.10.7.2.3 
	src/acl.c:1.1.1.3.10.5.2.2->1.1.1.3.10.5.2.3 
	src/asn.c:1.1.1.3.6.1.2.1->1.1.1.3.6.1.2.2 
	src/cache_cf.c:1.1.1.3.10.4.2.2->1.1.1.3.10.4.2.3 
	src/cf.data.pre:1.1.1.3.10.6.2.4->1.1.1.3.10.6.2.5 
	src/cf_gen.c:1.1.1.3.10.2.2.1->1.1.1.3.10.2.2.2 
	src/client_side.c:1.1.1.3.10.7.2.4->1.1.1.3.10.7.2.5 
	src/comm_select.c:1.1.1.3.10.2.2.2->1.1.1.3.10.2.2.3 
	src/delay_pools.c:1.1.1.3.10.3.2.1->1.1.1.3.10.3.2.2 
	src/disk.c:1.1.1.3.6.2->1.1.1.3.6.2.2.1 
	src/dns_internal.c:1.1.1.1.10.4.2.2->1.1.1.1.10.4.2.3 
	src/forward.c:1.1.1.3.10.3.2.1->1.1.1.3.10.3.2.2 
	src/globals.h:1.1.1.3.10.3->1.1.1.3.10.3.2.1 
	src/http.c:1.1.1.3.10.4->1.1.1.3.10.4.2.1 
	src/ipc.c:1.1.1.3.10.4->1.1.1.3.10.4.2.1 
	src/mem.c:1.1.1.3.10.3.2.1->1.1.1.3.10.3.2.2 
	src/neighbors.c:1.1.1.3.10.3->1.1.1.3.10.3.2.1 
	src/protos.h:1.1.1.3.10.8.2.4->1.1.1.3.10.8.2.5 
	src/repl_modules.sh:1.1->1.1.6.1 
	src/snmp_agent.c:1.1.1.3.6.2->1.1.1.3.6.2.2.1 
	src/squid.h:1.1.1.3.10.2.2.1->1.1.1.3.10.2.2.2 
	src/ssl.c:1.1.1.3.10.3.2.1->1.1.1.3.10.3.2.2 
	src/stat.c:1.1.1.3.10.4.2.1->1.1.1.3.10.4.2.2 
	src/store.c:1.1.1.3.10.8.2.3->1.1.1.3.10.8.2.4 
	src/store_client.c:1.1.1.3.10.4.2.2->1.1.1.3.10.4.2.3 
	src/store_digest.c:1.1.1.3.6.1.2.1->1.1.1.3.6.1.2.2 
	src/store_dir.c:1.1.1.3.10.6.2.1->1.1.1.3.10.6.2.2 
	src/store_heap_replacement.c:1.1.1.1.6.2->1.1.1.1.6.2.2.1(DEAD) 
	src/store_io.c:1.1.1.1.10.6->1.1.1.1.10.6.2.1 
	src/store_log.c:1.1.1.2.10.2->1.1.1.2.10.2.2.1 
	src/store_swapin.c:1.1.1.3.10.4->1.1.1.3.10.4.2.1 
	src/store_swapout.c:1.1.1.3.10.5.2.1->1.1.1.3.10.5.2.2 
	src/structs.h:1.1.1.3.10.8.2.5->1.1.1.3.10.8.2.6 
	src/typedefs.h:1.1.1.3.10.6.2.1->1.1.1.3.10.6.2.2 
	src/url.c:1.1.1.3.10.2->1.1.1.3.10.2.2.1 
	src/fs/aufs/async_io.c:1.1.6.1.2.3->1.1.6.1.2.4 
	src/fs/aufs/store_asyncufs.h:1.1.6.3.2.1->1.1.6.3.2.2 
	src/fs/aufs/store_dir_aufs.c:1.1.6.6.2.2->1.1.6.6.2.3 
	src/fs/aufs/store_io_aufs.c:1.1.6.6.2.2->1.1.6.6.2.3 
	src/fs/coss/store_coss.h:1.1.4.4->1.1.4.4.2.1 
	src/fs/coss/store_dir_coss.c:1.1.4.6.2.1->1.1.4.6.2.2 
	src/fs/coss/store_io_coss.c:1.1.4.8.2.3->1.1.4.8.2.4 
	src/fs/diskd/diskd.c:1.1.6.1->1.1.6.2 
	src/fs/diskd/store_dir_diskd.c:1.1.6.1->1.1.6.2 
	src/fs/diskd/store_diskd.h:1.1.6.1->1.1.6.2 
	src/fs/diskd/store_io_diskd.c:1.1.6.1->1.1.6.2 
	src/fs/ufs/store_dir_ufs.c:1.1.6.6.2.2->1.1.6.6.2.3 
	src/fs/ufs/store_io_ufs.c:1.1.6.6.2.3->1.1.6.6.2.4 
	src/fs/ufs/store_ufs.h:1.1.6.3.2.1->1.1.6.3.2.2 
	src/repl/Makefile.in:1.1->1.1.6.1 
	src/repl/heap/Makefile.in:1.1->1.1.6.1 
	src/repl/heap/store_heap_replacement.c:1.1->1.1.6.1 
	src/repl/heap/store_heap_replacement.h:1.1->1.1.6.1 
	src/repl/heap/store_repl_heap.c:1.1->1.1.6.1 
	src/repl/lru/Makefile.in:1.1->1.1.6.1 
	src/repl/lru/store_repl_lru.c:1.1->1.1.6.1 

Index: squid/configure.in
===================================================================
RCS file: /cvsroot/squid-sf//squid/configure.in,v
retrieving revision 1.1.1.3.6.7.2.6
retrieving revision 1.1.1.3.6.7.2.7
diff -u -r1.1.1.3.6.7.2.6 -r1.1.1.3.6.7.2.7
--- squid/configure.in	8 May 2000 18:02:07 -0000	1.1.1.3.6.7.2.6
+++ squid/configure.in	14 May 2000 23:22:19 -0000	1.1.1.3.6.7.2.7
@@ -3,13 +3,13 @@
 dnl
 dnl  Duane Wessels, wessels@nlanr.net, February 1996 (autoconf v2.9)
 dnl
-dnl  $Id: configure.in,v 1.1.1.3.6.7.2.6 2000/05/08 18:02:07 hno Exp $
+dnl  $Id: configure.in,v 1.1.1.3.6.7.2.7 2000/05/14 23:22:19 hno Exp $
 dnl
 dnl
 dnl
 AC_INIT(src/main.c)
 AC_CONFIG_HEADER(include/autoconf.h)
-AC_REVISION($Revision: 1.1.1.3.6.7.2.6 $)dnl
+AC_REVISION($Revision: 1.1.1.3.6.7.2.7 $)dnl
 AC_PREFIX_DEFAULT(/usr/local/squid)
 AC_CONFIG_AUX_DIR(cfgaux)
 
@@ -320,6 +320,49 @@
 STORE_OBJS="fs/`echo $STORE_MODULES|sed -e's% %.a fs/%g'`.a"
 AC_SUBST(STORE_OBJS)
 
+dnl --enable-heap-replacement compability option
+AC_ARG_ENABLE(heap-replacement,
+[  --enable-heap-replacement
+                          Backwards compability option. Please use the
+			  new --enable-removal-policies directive instead.],
+[ if test "$enableval" = "yes" ; then
+    echo "--enable-heap-replacement is obsolete. please use the new"
+    echo "--enable-removal-policies directive instead"
+    sleep 5
+    REPL_POLICIES="heap"
+  fi
+])
+
+AC_ARG_ENABLE(removal_policies,
+[  --enable-removal-policies=\"list of policies\"
+                          Build support for the list of removal policies.
+                          The default is only to build the "lru" module.
+                          See src/repl for a list of available modules, or
+                          Programmers Guide section 9.9 for details on how
+			  to build your custom policy],
+[ case $enableval in
+  yes)
+	for module in $srcdir/src/repl/*; do
+	    if test -f $module/Makefile.in; then
+		REPL_POLICIES="$REPL_POLICIES `basename $module`"
+	    fi
+	done
+  	;;
+  no)
+  	;;
+  *)	REPL_POLICIES="`echo $enableval| sed -e 's/,/ /g;s/  */ /g'`"
+	;;
+  esac
+],
+[ if test -z "$REPL_POLICIES"; then
+    REPL_POLICIES="lru"
+  fi
+])
+echo "Store modules built: $REPL_POLICIES"
+AC_SUBST(REPL_POLICIES)
+REPL_OBJS="repl/`echo $REPL_POLICIES|sed -e's% %.a repl/%g'`.a"
+AC_SUBST(REPL_OBJS)
+
 AC_ARG_ENABLE(icmp,
 [  --enable-icmp           Enable ICMP pinging],
 [ if test "$enableval" = "yes" ; then
@@ -592,18 +635,6 @@
   fi
 ])
 
-dnl Enable HEAP_REPLACEMENT
-AC_ARG_ENABLE(heap-replacement,
-[  --enable-heap-replacement
-                          This option allows you to use various cache
-                          replacement algorithms, instead of the standard
-                          LRU algorithm.],
-[ if test "$enableval" = "yes" ; then
-    echo "Enabling HEAP_REPLACEMENT"
-    AC_DEFINE(HEAP_REPLACEMENT, 1)
-  fi
-])
-
 dnl Select auth modules to build
 AUTH_MODULES=
 AC_ARG_ENABLE(auth-modules,
@@ -1579,6 +1610,9 @@
 	./src/fs/ufs/Makefile \
 	./src/fs/aufs/Makefile \
 	./src/fs/coss/Makefile \
+	./src/repl/Makefile \
+	./src/repl/lru/Makefile \
+	./src/repl/heap/Makefile \
 	./src/fs/diskd/Makefile \
 	./contrib/Makefile \
 	$SNMP_MAKEFILE \
Index: squid/doc/Programming-Guide/prog-guide.sgml
===================================================================
RCS file: /cvsroot/squid-sf//squid/doc/Programming-Guide/prog-guide.sgml,v
retrieving revision 1.1.1.2.6.1.2.1
retrieving revision 1.1.1.2.6.1.2.2
diff -u -r1.1.1.2.6.1.2.1 -r1.1.1.2.6.1.2.2
--- squid/doc/Programming-Guide/prog-guide.sgml	2 May 2000 22:50:28 -0000	1.1.1.2.6.1.2.1
+++ squid/doc/Programming-Guide/prog-guide.sgml	14 May 2000 23:22:19 -0000	1.1.1.2.6.1.2.2
@@ -2,7 +2,7 @@
 <article>
 <title>Squid Programmers Guide</title>
 <author>Duane Wessels, Squid Developers
-<date>$Id: prog-guide.sgml,v 1.1.1.2.6.1.2.1 2000/05/02 22:50:28 hno Exp $</date>
+<date>$Id: prog-guide.sgml,v 1.1.1.2.6.1.2.2 2000/05/14 23:22:19 hno Exp $</date>
 
 <abstract>
 Squid is a WWW Cache application developed by the National Laboratory
@@ -1492,16 +1492,16 @@
 	This feature may not be required by some storage systems
 	and can be implemented as a null-function (no-op).
 
-<sect2><tt/log.clean.open()/
+<sect2><tt/log.clean.start()/
 
 	<P>
 <verb>
 	int
-	STLOGCLEANOPEN(SwapDir *);
+	STLOGCLEANSTART(SwapDir *);
 </verb>
 
 	<P>
-	The <tt/log.clean.open/ function, of type <em/STLOGCLEANOPEN/,
+	The <tt/log.clean.start/ function, of type <em/STLOGCLEANSTART/,
 	is used for the process of writing "clean" state-holding
 	log files.  The clean-writing procedure is initiated by
 	the <em/squid -k rotate/ command.  This is a special case
@@ -1514,24 +1514,45 @@
 	keep state information for the clean-writing process, but
 	should not be accessed by upper layers.
 
+<sect2><tt/log.clean.nextentry()/
+
+	<P>
+<verb>
+	StoreEntry *
+	STLOGCLEANNEXTENTRY(SwapDir *);
+</verb>
+
+	<P>
+	Gets the next entry that is a candidate for the clean log.
+
+	<P>
+	Returns NULL when there is no more objects to log
+
 <sect2><tt/log.clean.write()/
 
 	<P>
 <verb>
 	void
-	STLOGCLEANWRITE(const StoreEntry *, SwapDir *);
+	STLOGCLEANWRITE(SwapDir *, const StoreEntry *);
 </verb>
 
 	<P>
 	The <tt/log.clean.write/ function, of type <em/STLOGCLEANWRITE/,
 	writes an entry to the clean log file (if any).
 
+<sect2><tt/log.clean.done()/
+
 	<P>
-	A NULL <em/StoreEntry/ argument indicates the end of
-	the clean-writing process and signals the storage
-	system to close the clean log, and rename or move them
-	to become the official state-holding log.
+<verb>
+	void
+	STLOGCLEANDONE(SwapDir *);
+</verb>
 
+	<P>
+	Indicates the end of the clean-writing process and signals
+	the storage system to close the clean log, and rename or
+	move them to become the official state-holding log ready
+	to be opened.
 
 <sect1>Replacement policy implementation
 
@@ -1545,10 +1566,7 @@
 coupling between the storage layer and the replacement policy.
 
 
-<sect1>Future removal policy
-
-	<P>
-	(replaces the above Replace policy)
+<sect1>Removal policy API
 
 	<P>
 	The removal policy is responsible for determining in which order
@@ -1625,10 +1643,26 @@
 </verb>
 
 	<P>
-	Tells the policy that a StoreEntry has been referenced.
+	Tells the policy that a StoreEntry is going to be referenced. Called
+	whenever a entry gets locked.
 
 	<P>
-	datap is a pointer to where policy specific data is stored
+	node is a pointer to where policy specific data is stored
+	for the store entry, currently the size of one (void *) pointer.
+
+<sect3>policy.Dereferenced()
+
+<P>
+<verb>
+	policy-&gt;Dereferenced(RemovalPolicy *policy, const StoreEntry *, RemovalPolicyNode *node)
+</verb>
+
+	<P>
+	Tells the policy that a StoreEntry has been referenced. Called when
+	an access to the entry has finished.
+
+	<P>
+	node is a pointer to where policy specific data is stored
 	for the store entry, currently the size of one (void *) pointer.
 
 <sect3>policy.WalkInit()
@@ -1822,6 +1856,32 @@
 	Prior to returning the created instance must be registered as
 	callback-data by calling cbdataAdd().
 
+<sect2>Design notes/bugs
+
+<P>
+	The RemovalPolicyNode design is incomplete/insufficient. The intention
+	was to abstract the location of the index pointers from the policy
+	implementation to allow the policy to work on both on-disk and memory
+	caches, but unfortunately the purge method for HEAP based policies
+	needs to update this, and it is also preferable if the purge method
+	in general knows how to clear the information. I think the agreement
+	was that the current design of thightly coupling the two together
+	on one StoreEntry is not the best design possible.
+
+<P>
+	It is debated if the design in having the policy index control the
+	clean index writes is the correct approach. Perhaps not. Perhaps a
+	more appropriate design is probably to do the store indexing
+	completely outside the policy implementation (i.e. using the hash
+	index), and only ask the policy to dump it's state somehow.
+
+<P>
+	The Referenced/Dereferenced() calls is today mapped to lock/unlock
+	which is an approximation of when they are intended to be called.
+	However, the real intention is to have Referenced() called whenever
+	an object is referenced, and Dereferenced() only called when the
+	object has actually been used for anything good.
+
 <!-- %%%% Chapter : FORWARDING SELECTION %%%% -->
 <sect>Forwarding Selection
 
Index: squid/lib/rfc1035.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/rfc1035.c,v
retrieving revision 1.1.1.1.10.2
retrieving revision 1.1.1.1.10.2.2.1
diff -u -r1.1.1.1.10.2 -r1.1.1.1.10.2.2.1
--- squid/lib/rfc1035.c	20 Apr 2000 18:14:21 -0000	1.1.1.1.10.2
+++ squid/lib/rfc1035.c	14 May 2000 23:22:19 -0000	1.1.1.1.10.2.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: rfc1035.c,v 1.1.1.1.10.2 2000/04/20 18:14:21 hno Exp $
+ * $Id: rfc1035.c,v 1.1.1.1.10.2.2.1 2000/05/14 23:22:19 hno Exp $
  *
  * Low level DNS protocol routines
  * AUTHOR: Duane Wessels
@@ -93,6 +93,11 @@
     unsigned short arcount;
 };
 
+static const char *Alphanum =
+"abcdefghijklmnopqrstuvwxyz"
+"ABCDEFGHIJKLMNOPQRSTUVWXYZ"
+"0123456789";
+
 /*
  * rfc1035HeaderPack()
  * 
@@ -362,6 +367,39 @@
     return qid;
 }
 
+static void
+rfc1035SetErrno(int n)
+{
+    switch (rfc1035_errno = n) {
+    case 0:
+	rfc1035_error_message = "No error condition";
+	break;
+    case 1:
+	rfc1035_error_message = "Format Error: The name server was "
+	    "unable to interpret the query.";
+	break;
+    case 2:
+	rfc1035_error_message = "Server Failure: The name server was "
+	    "unable to process this query.";
+	break;
+    case 3:
+	rfc1035_error_message = "Name Error: The domain name does "
+	    "not exist.";
+	break;
+    case 4:
+	rfc1035_error_message = "Not Implemented: The name server does "
+	    "not support the requested kind of query.";
+	break;
+    case 5:
+	rfc1035_error_message = "Refused: The name server refuses to "
+	    "perform the specified operation.";
+	break;
+    default:
+	rfc1035_error_message = "Unknown Error";
+	break;
+    }
+}
+
 void
 rfc1035RRDestroy(rfc1035_rr * rr, int n)
 {
@@ -393,35 +431,7 @@
     rfc1035_errno = 0;
     rfc1035_error_message = NULL;
     if (hdr.rcode) {
-	rfc1035_errno = (int) hdr.rcode;
-	switch (rfc1035_errno) {
-	case 0:
-	    rfc1035_error_message = "No error condition";
-	    break;
-	case 1:
-	    rfc1035_error_message = "Format Error: The name server was "
-		"unable to interpret the query.";
-	    break;
-	case 2:
-	    rfc1035_error_message = "Server Failure: The name server was "
-		"unable to process this query.";
-	    break;
-	case 3:
-	    rfc1035_error_message = "Name Error: The domain name does "
-		"not exist.";
-	    break;
-	case 4:
-	    rfc1035_error_message = "Not Implemented: The name server does "
-		"not support the requested kind of query.";
-	    break;
-	case 5:
-	    rfc1035_error_message = "Refused: The name server refuses to "
-		"perform the specified operation.";
-	    break;
-	default:
-	    rfc1035_error_message = "Unknown Error";
-	    break;
-	}
+	rfc1035SetErrno((int) hdr.rcode);
 	return -rfc1035_errno;
     }
     i = (int) hdr.qdcount;
@@ -471,6 +481,11 @@
     off_t offset = 0;
     size_t sz = *szp;
     memset(&h, '\0', sizeof(h));
+    /* the first char of hostname must be alphanmeric */
+    if (NULL == strchr(Alphanum, *hostname)) {
+	rfc1035SetErrno(3);
+	return 0;
+    }
     h.id = rfc1035Qid();
     h.qr = 0;
     h.rd = 1;
Index: squid/src/acl.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/acl.c,v
retrieving revision 1.1.1.3.10.5.2.2
retrieving revision 1.1.1.3.10.5.2.3
diff -u -r1.1.1.3.10.5.2.2 -r1.1.1.3.10.5.2.3
--- squid/src/acl.c	2 May 2000 23:21:53 -0000	1.1.1.3.10.5.2.2
+++ squid/src/acl.c	14 May 2000 23:22:19 -0000	1.1.1.3.10.5.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: acl.c,v 1.1.1.3.10.5.2.2 2000/05/02 23:21:53 hno Exp $
+ * $Id: acl.c,v 1.1.1.3.10.5.2.3 2000/05/14 23:22:19 hno Exp $
  *
  * DEBUG: section 28    Access Control
  * AUTHOR: Duane Wessels
@@ -1075,7 +1075,7 @@
  */
 
 static int
-aclMatchProxyAuth(void * data, const char *proxy_auth, acl_proxy_auth_user * auth_user, aclCheck_t * checklist, squid_acl acltype)
+aclMatchProxyAuth(void *data, const char *proxy_auth, acl_proxy_auth_user * auth_user, aclCheck_t * checklist, squid_acl acltype)
 {
     /* checklist is used to register user name when identified, nothing else */
     LOCAL_ARRAY(char, login_buf, USER_IDENT_SZ);
@@ -1142,14 +1142,14 @@
 	    auth_user->ipaddr = checklist->src_addr;
 	    /* copy username to request for logging on client-side */
 	    xstrncpy(checklist->request->user_ident, user, USER_IDENT_SZ);
-	    switch(acltype) {
+	    switch (acltype) {
 	    case ACL_PROXY_AUTH:
 		return aclMatchUser(data, user);
 	    case ACL_PROXY_AUTH_REGEX:
 		return aclMatchRegex(data, user);
 	    default:
 		fatal("aclMatchProxyAuth: unknown ACL type");
-		return 0; /* NOTREACHED */
+		return 0;	/* NOTREACHED */
 	    }
 	} else {
 	    if (Config.onoff.authenticateIpTTLStrict) {
@@ -2004,16 +2004,16 @@
     const char *d1;
     const char *d2;
     int ret;
-    d1=b;
-    d2=a;
+    d1 = b;
+    d2 = a;
     ret = aclHostDomainCompare(d1, d2);
     if (ret != 0) {
-	d1=a;
-	d2=b;
+	d1 = a;
+	d2 = b;
 	ret = aclHostDomainCompare(d1, d2);
     }
     if (ret == 0) {
-	debug(28,0 ) ("WARNING: '%s' is a subdomain of '%s'\n", d1, d2);
+	debug(28, 0) ("WARNING: '%s' is a subdomain of '%s'\n", d1, d2);
 	debug(28, 0) ("WARNING: because of this '%s' is ignored to keep splay tree searching predictable\n", a);
 	debug(28, 0) ("WARNING: You should probably remove '%s' from the ACL named '%s'\n", d1, AclMatchedName);
     }
Index: squid/src/asn.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/asn.c,v
retrieving revision 1.1.1.3.6.1.2.1
retrieving revision 1.1.1.3.6.1.2.2
diff -u -r1.1.1.3.6.1.2.1 -r1.1.1.3.6.1.2.2
--- squid/src/asn.c	8 May 2000 18:02:07 -0000	1.1.1.3.6.1.2.1
+++ squid/src/asn.c	14 May 2000 23:22:19 -0000	1.1.1.3.6.1.2.2
@@ -1,5 +1,5 @@
 /*
- * $Id: asn.c,v 1.1.1.3.6.1.2.1 2000/05/08 18:02:07 hno Exp $
+ * $Id: asn.c,v 1.1.1.3.6.1.2.2 2000/05/14 23:22:19 hno Exp $
  *
  * DEBUG: section 53    AS Number handling
  * AUTHOR: Duane Wessels, Kostas Anagnostakis
@@ -206,7 +206,7 @@
     asState->seen = 0;
     asState->offset = 0;
     storeClientCopy(asState->sc,
-        e,
+	e,
 	asState->seen,
 	asState->offset,
 	4096,
@@ -262,7 +262,7 @@
     if (e->store_status == STORE_PENDING) {
 	debug(53, 3) ("asHandleReply: store_status == STORE_PENDING: %s\n", storeUrl(e));
 	storeClientCopy(asState->sc,
-            e,
+	    e,
 	    asState->seen,
 	    asState->offset,
 	    SM_PAGE_SIZE,
@@ -272,7 +272,7 @@
     } else if (asState->seen < e->mem_obj->inmem_hi) {
 	debug(53, 3) ("asHandleReply: asState->seen < e->mem_obj->inmem_hi %s\n", storeUrl(e));
 	storeClientCopy(asState->sc,
-            e,
+	    e,
 	    asState->seen,
 	    asState->offset,
 	    SM_PAGE_SIZE,
Index: squid/src/cache_cf.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cache_cf.c,v
retrieving revision 1.1.1.3.10.4.2.2
retrieving revision 1.1.1.3.10.4.2.3
diff -u -r1.1.1.3.10.4.2.2 -r1.1.1.3.10.4.2.3
--- squid/src/cache_cf.c	23 Apr 2000 09:55:37 -0000	1.1.1.3.10.4.2.2
+++ squid/src/cache_cf.c	14 May 2000 23:22:19 -0000	1.1.1.3.10.4.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: cache_cf.c,v 1.1.1.3.10.4.2.2 2000/04/23 09:55:37 hno Exp $
+ * $Id: cache_cf.c,v 1.1.1.3.10.4.2.3 2000/05/14 23:22:19 hno Exp $
  *
  * DEBUG: section 3     Configuration File Parsing
  * AUTHOR: Harvest Derived
@@ -113,7 +113,7 @@
 }
 
 void
-wordlistJoin(wordlist ** list, wordlist **wl)
+wordlistJoin(wordlist ** list, wordlist ** wl)
 {
     while (*list)
 	list = &(*list)->next;
@@ -122,14 +122,14 @@
 }
 
 void
-wordlistAddWl(wordlist ** list, wordlist *wl)
+wordlistAddWl(wordlist ** list, wordlist * wl)
 {
     while (*list)
 	list = &(*list)->next;
-    for(;wl;wl=wl->next, list = &(*list)->next) {
+    for (; wl; wl = wl->next, list = &(*list)->next) {
 	*list = memAllocate(MEM_WORDLIST);
 	(*list)->key = xstrdup(wl->key);
-    (*list)->next = NULL;
+	(*list)->next = NULL;
     }
 }
 
@@ -200,8 +200,8 @@
     size_t ms = -1;
 
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
-        if (Config.cacheSwap.swapDirs[i].max_objsize > ms)
-            ms = Config.cacheSwap.swapDirs[i].max_objsize; 
+	if (Config.cacheSwap.swapDirs[i].max_objsize > ms)
+	    ms = Config.cacheSwap.swapDirs[i].max_objsize;
     }
     store_maxobjsize = ms;
 }
@@ -348,14 +348,6 @@
 	debug(3, 0) ("WARNING: resetting 'maximum_single_addr_tries to 1\n");
 	Config.retry.maxtries = 1;
     }
-#if HEAP_REPLACEMENT
-    /* The non-LRU policies do not use referenceAge */
-#else
-    if (Config.referenceAge < 300) {
-	debug(3, 0) ("WARNING: resetting 'reference_age' to 1 week\n");
-	Config.referenceAge = 86400 * 7;
-    }
-#endif
     requirePathnameExists("MIME Config Table", Config.mimeTablePathname);
 #if USE_DNSSERVERS
     requirePathnameExists("cache_dns_program", Config.Program.dnsserver);
@@ -816,7 +808,7 @@
     int i;
     for (i = 0; i < swap.n_configured; i++) {
 	s = swap.swapDirs + i;
-        s->dump(entry, name, s);
+	s->dump(entry, name, s);
     }
 }
 
@@ -854,7 +846,7 @@
 {
     int i;
     for (i = 0; storefs_list[i].typestr != NULL; i++) {
-        if (strcasecmp(type, storefs_list[i].typestr) == 0) {
+	if (strcasecmp(type, storefs_list[i].typestr) == 0) {
 	    return i;
 	}
     }
@@ -874,7 +866,7 @@
     if ((type_str = strtok(NULL, w_space)) == NULL)
 	self_destruct();
 
-    maxobjsize = (size_t)GetInteger();
+    maxobjsize = (size_t) GetInteger();
 
     if ((path_str = strtok(NULL, w_space)) == NULL)
 	self_destruct();
@@ -898,26 +890,25 @@
      */
 
     for (i = 0; i < swap->n_configured; i++) {
-        if (0 == strcasecmp(path_str, swap->swapDirs[i].path)) {
+	if (0 == strcasecmp(path_str, swap->swapDirs[i].path)) {
 	    /* This is a little weird, you'll appreciate it later */
 	    fs = find_fstype(type_str);
 	    if (fs < 0) {
-                fatalf("Unknown cache_dir type '%s'\n", type_str);
+		fatalf("Unknown cache_dir type '%s'\n", type_str);
 	    }
 	    sd = swap->swapDirs + i;
 	    storefs_list[fs].reconfigurefunc(sd, i, path_str);
-            sd->max_objsize = maxobjsize;
-            update_maxobjsize();
-            return;
+	    sd->max_objsize = maxobjsize;
+	    update_maxobjsize();
+	    return;
 	}
     }
 
     fs = find_fstype(type_str);
     if (fs < 0) {
-        /* If we get here, we didn't find a matching cache_dir type */
-        fatalf("Unknown cache_dir type '%s'\n", type_str);
+	/* If we get here, we didn't find a matching cache_dir type */
+	fatalf("Unknown cache_dir type '%s'\n", type_str);
     }
-
     allocate_new_swapdir(swap);
     sd = swap->swapDirs + swap->n_configured;
     storefs_list[fs].parsefunc(sd, swap->n_configured, path_str);
@@ -1494,7 +1485,7 @@
 }
 
 static int
-check_null_refreshpattern(refresh_t *data)
+check_null_refreshpattern(refresh_t * data)
 {
     return data != NULL;
 }
@@ -1705,6 +1696,40 @@
     storeAppendPrintf(entry, "%s %s\n", name, s);
 }
 
+static void
+free_removalpolicy(RemovalPolicySettings **settings)
+{
+    if (!*settings)
+	return;
+    free_string(&(*settings)->type);
+    free_wordlist(&(*settings)->args);
+    xfree(*settings);
+    *settings = NULL;
+}
+
+static void
+parse_removalpolicy(RemovalPolicySettings **settings)
+{
+    if (*settings)
+	free_removalpolicy(settings);
+    *settings = xcalloc(1, sizeof(**settings));
+    parse_string(&(*settings)->type);
+    parse_wordlist(&(*settings)->args);
+}
+
+static void
+dump_removalpolicy(StoreEntry * entry, const char *name, RemovalPolicySettings *settings)
+{
+    wordlist *args;
+    storeAppendPrintf(entry, "%s %s", name, settings->type);
+    args = settings->args;
+    while (args) {
+	storeAppendPrintf(entry, " %s", args->key);
+	args = args->next;
+    }
+}
+    
+
 #include "cf_parser.c"
 
 peer_t
@@ -1806,3 +1831,5 @@
     if (stat(path, &sb) < 0)
 	fatalf("%s: %s", path, xstrerror());
 }
+
+
Index: squid/src/cf.data.pre
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cf.data.pre,v
retrieving revision 1.1.1.3.10.6.2.4
retrieving revision 1.1.1.3.10.6.2.5
diff -u -r1.1.1.3.10.6.2.4 -r1.1.1.3.10.6.2.5
--- squid/src/cf.data.pre	8 May 2000 18:02:07 -0000	1.1.1.3.10.6.2.4
+++ squid/src/cf.data.pre	14 May 2000 23:22:19 -0000	1.1.1.3.10.6.2.5
@@ -1,6 +1,6 @@
 
 #
-# $Id: cf.data.pre,v 1.1.1.3.10.6.2.4 2000/05/08 18:02:07 hno Exp $
+# $Id: cf.data.pre,v 1.1.1.3.10.6.2.5 2000/05/14 23:22:19 hno Exp $
 #
 #
 # SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -580,6 +580,58 @@
 	Maximum number of FQDN cache entries.
 DOC_END
 
+NAME: cache_replacement_policy
+TYPE: removalpolicy
+LOC: Config.replPolicy
+DEFAULT: lru
+DOC_START
+	The cache replacement policy parameter determines which
+	objects are evicted (replaced) when disk space is needed.
+
+	    lru       : Squid's original list based LRU policy
+	    heap GDSF : Greedy-Dual Size Frequency
+	    heap LFUDA: Least Frequently Used with Dynamic Aging
+	    heap LRU  : LRU policy implemented using a heap
+
+	Applies to any cache_dir lines listed below this.
+
+	The LRU policies keeps recently referenced objects.
+
+	The heap GDSF policy optimizes object hit rate by keeping smaller
+	popular objects in cache so it has a better chance of getting a
+	hit.  It achieves a lower byte hit rate than LFUDA though since
+	it evicts larger (possibly popular) objects.
+
+	The heap LFUDA policy keeps popular objects in cache regardless of
+	their size and thus optimizes byte hit rate at the expense of
+	hit rate since one large, popular object will prevent many
+	smaller, slightly less popular objects from being cached.
+
+	Both policies utilize a dynamic aging mechanism that prevents
+	cache pollution that can otherwise occur with frequency-based
+	replacement policies.
+
+	NOTE: if using the LFUDA replacement policy you should increase
+	the value of maximum_object_size above its default of 4096 KB to
+	to maximize the potential byte hit rate improvement of LFUDA.  
+
+	For more information about the GDSF and LFUDA cache replacement
+	policies see http://www.hpl.hp.com/techreports/1999/HPL-1999-69.html
+	and http://fog.hpl.external.hp.com/techreports/98/HPL-98-173.html.
+DOC_END
+
+NAME: memory_replacement_policy
+TYPE: removalpolicy
+LOC: Config.memPolicy
+DEFAULT: lru
+DOC_START
+	The memory replacement policy parameter determines which
+	objects are purged from memory when memory space is needed.
+
+	See cache_replacement_policy for details.
+DOC_END
+
+
 COMMENT_START
  LOGFILE PATHNAMES AND CACHE DIRECTORIES
  -----------------------------------------------------------------------------
@@ -593,7 +645,11 @@
 DOC_START
 	Usage:
 	
-	cache_dir Type Maxobjsize Directory-Name Mbytes Level-1 Level2
+	cache_dir Type Maxobjsize Directory-Name Mbytes Level-1 Level2 [...]
+
+	DISKD Usage:
+
+	cache_dir diskd Maxobjsize Directory-Name MB L1 L2 Q1 Q2
 
 	You can specify multiple cache_dir lines to spread the
 	cache among different disk partitions.
@@ -627,6 +683,13 @@
 	'Level-2' is the number of second-level subdirectories which
 	will be created under each first-level directory.  The default
 	is 256.
+
+	For the diskd type, Q1 specifies the number of unacknowledged
+	I/O requests when Squid stops opening new files.  If this
+	many messages are in the queues, Squid won't open new files.
+	Q2 specifies the number of unacknowledged messages when Squid
+	starts blocking.  If this many messages are in the queues,
+	Squid blocks until it recevies some replies.
 DOC_END
 
 
@@ -1194,49 +1257,6 @@
 	used.
 DOC_END
 
-
-NAME: replacement_policy
-TYPE: string
-LOC: Config.replPolicy
-DEFAULT: LFUDA
-IFDEF: HEAP_REPLACEMENT
-DOC_START
-	The cache replacement policy parameter determines which
-	objects are evicted (replaced) when disk space is needed.
-	Squid used to have only a single replacement policy, LRU.
-	But when built with -DHEAP_REPLACEMENT you can choose
-	between two new, enhanced policies:
-
-		   GDSF: Greedy-Dual Size Frequency
-		   LFUDA: Least Frequently Used with Dynamic Aging
-
-	Both of these policies are frequency based rather than recency
-	based, and perform better than LRU.
-
-	The GDSF policy optimizes object hit rate by keeping smaller
-	popular objects in cache so it has a better chance of getting a
-	hit.  It achieves a lower byte hit rate than LFUDA though since
-	it evicts larger (possibly popular) objects.
-
-	The LFUDA policy keeps popular objects in cache regardless of
-	their size and thus optimizes byte hit rate at the expense of
-	hit rate since one large, popular object will prevent many
-	smaller, slightly less popular objects from being cached.
-
-	Both policies utilize a dynamic aging mechanism that prevents
-	cache pollution that can otherwise occur with frequency-based
-	replacement policies.
-
-	NOTE: if using the LFUDA replacement policy you should increase
-	the value of maximum_object_size above its default of 4096 KB to
-	to maximize the potential byte hit rate improvement of LFUDA.  
-
-	For more information about these cache replacement policies see
-	http://www.hpl.hp.com/techreports/1999/HPL-1999-69.html and
-	http://fog.hpl.external.hp.com/techreports/98/HPL-98-173.html.
-DOC_END
-
-
 NAME: reference_age
 TYPE: time_t
 LOC: Config.referenceAge
@@ -3130,21 +3150,5 @@
 	disable persistent connections with clients and/or servers.
 DOC_END
 
-NAME: diskd_magic1
-IFDEF: USE_DISKD
-TYPE: int
-LOC: Config.diskd.magic1
-DEFAULT: 64
-DOC_NONE
-
-NAME: diskd_magic2
-IFDEF: USE_DISKD
-TYPE: int
-LOC: Config.diskd.magic2
-DEFAULT: 72
-DOC_START
-	Macic constants for the diskd daemon..
-DOC_END
-
 EOF
 
